import rfc822_message_parse
import rfc822_message
import rfc822_address
import rfc822_attachment
import cStringIO
import time
import string


def store_message(container, message, readonly=None):
	"""A method that adds an rfc822_message object
	to the container, and possibly address fields.
	It may also add attachments."""

	message_id = str(container.get_id())

	if message.attachments:

		message_id = message_id + '_attachments'

	if not string.strip(message.subject):

		message.subject = '[No subject]'
		message.headers['subject'] = message.subject

	rfc822_message.manage_add_rfc822_message(container, message_id,
											 sender=message.sender[-1],
											 body=message.body,
											 subject=message.subject,
											 reply_to=message.reply_to)


	message_reference = container[message_id]

	for recipient in message.to:

		message_reference['to'].manage_add_rfc822_address(
			str(container.get_unique_id()),
			recipient[-1],
			comment='comment',
			realname='realname')

		#new_id = str(self.get_unique_id())
		#message_reference['to'].manage_addDTMLDocument(new_id,'')
		#message_reference['to'][new_id].address = recipient[-1]
		#message_reference['to'][new_id].comment = 'comment'
		#message_reference['to'][new_id].realname = 'realname'

	for recipient in message.cc:

		pass

		#message_reference['cc'].manage_add_rfc822_address(str(container.get_unique_id()),
		#												  recipient[-1],
		#												  'comment',
		#												  'realname')

		#new_id = str(self.get_unique_id())
		#message_reference['cc'].manage_addDTMLDocument(new_id,'')
		#message_reference['cc'][new_id].address = recipient[-1]
		#message_reference['cc'][new_id].comment = 'comment'
		#message_reference['cc'][new_id].realname = 'realname'

	for recipient in message.bcc:

		pass

		#message_reference['bcc'].manage_add_rfc822_address(str(container.get_unique_id()),
		#												   recipient[-1],
		#												   'comment',
		#												   'realname')

		#new_id = str(self.get_unique_id())
		#message_reference['bcc'].manage_addDTMLDocument(new_id,'')
		#message_reference['bcc'][new_id].address = recipient[-1]
		#message_reference['bcc'][new_id].comment = 'comment'
		#message_reference['bcc'][new_id].realname = 'realname'

			
	if readonly:

		message_reference.readonly = 1

	else:

		message_reference.readonly = 0

	return message_reference


def store_unparsed_message(container, unparsed_rfc822_message):
	"""This method lets us parse a message before storing it."""

	if type(unparsed_rfc822_message) is type(''):

		unparsed_rfc822_message = my_string_io(unparsed_rfc822_message)

	message = rfc822_message_parse.rfc822_message_parse(
		unparsed_rfc822_message)

	store_message(container, message)


class my_string_io:
	"""This class represents a wrapper for a cStringIO.StringIO instance,
	giving the ability to use the readlines method."""

	# Should we use a __getattr__ wrapper instead of per-method wrapping?
	# This will prevent breakage of future methods StringIO may have...

	def __init__(self, data=''):

		self._fp = cStringIO.StringIO(data)


	def close(self):

		return self._fp.close()


	def flush(self):

		return self._fp.flush()


	def isatty(self):

		return self._fp.isatty()


	def fileno(self):

		return self._fp.fileno()


	def read(self, size=None):

		if size:

			return self._fp.read(size)

		return self._fp.read()


	def readline(self):

		return self._fp.readline()


	def readlines(self):

		return_list = []

		tmp = None

		while 1:

			tmp = self._fp.readline()

			if tmp:

				return_list.append(tmp)

			else:

				break

		return return_list


	def seek(self, offset, whence=None):

		if whence:

			return self._fp.seek(offset, whence)

		return self._fp.seek(offset)


	def tell(self):

		return self._fp.tell()


	def truncate(self, size=None):

		if size:
			
			return self._fp.truncate(size)

		return self._fp.truncate()


	def write(self, _string):

		return self._fp.write(_string)


	def writelines(self, lines):

		return self._fp.writelines(lines)
