###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.0 $

__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import todo


categoryAdd2 = HTMLFile('categoryAdd2', globals())
manage_addCategoryForm = HTMLFile('categoryAdd', globals())


def manage_addCategory(self, id, title, REQUEST=None):
    "Add an instance of the Category class"
    self._setObject(id, Category(id, title))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class Category(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager
	):
	"Documentation string"

	meta_type = 'Category'
	icon = 'misc_/TodoFolder/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	meta_types = (
		{'name':'Todo', 'action':'manage_addTodoForm'},
		)

	manage_addTodoForm = todo.manage_addTodoForm
	manage_addTodo = todo.manage_addTodo
	todoAdd2 = todo.todoAdd2

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Todo',
		 ('manage_addTodo', 'manage_addTodoForm')),
		('View Categorys',
		 ('',)),
		)

	index_html = HTMLFile('categoryIndex', globals())

	def __init__(self, id, title=''):
		"Initialize the class instance"

		self.id = id
		self.title = title

		#self.todo_level = 0


	#def get_level(self):
	#	"""Returns the current level and increments the counter."""
	#
	#	self.todo_level = self.todo_level + 1

	#return str(self.todo_level)


	def __call__(self):

		raise 'Waaa'


	def display(self):
		"""Returns a view suitable in a larger picture."""

		return_string = ""

		for todo in self.objectValues('Todo'):

			return_string = return_string + todo.display() + ''

		return return_string


default__class_init__(Category)

